"""
Abstract definition of a GridFTP storage service.
"""
__rcsid__ = '$Id: gridftp_store.py 24892 2010-06-12 00:43:29Z dang $'
__author__ = 'Dan Gunter <dkgunter@lbl.gov>'

class GridFTPStore:
    """Interface to a GridFTP data store.
    """
    def get_transfers(self, start, end):
        """Get all transfers in a time range.

        Parameters:

          - (datetime) start: beginning of time range
          - (datetime) end: end of time range

        Return:

          - (iterator) zero or more dicts representing the transfers
            between the 'start' and 'end' times.

        """
        pass
